'' I claim first GUI control for PropGFX! :)
'' Written by Jeff Ledger / Oldbitcollector

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

   DO  = 16      'Set these pins to match your SD connections.
   CLK = 17
   DI  = 18
   CS  = 19

   mouse = 26
   
  SPRX = 0
  SPRY = 1
  SPRP = 2
  SPRC = 3

VAR

  long  PropGFXInserted    
  word  scr
  long  mousex, mousey

OBJ
  Lite     : "GFX_BINARY_Databus"
  rat      : "mouse"
    
PUB Main | i,ocnt,x,y

  rat.start(mouse, mouse+1) 

  repeat

    PropGFXInserted:=0
    Lite.PropGFX_Start
    if(Lite.PropGFX_TestValid<>0)
      Lite.GetID
      PropGFXInserted:=Lite.RequestIDVersion
     
    if PropGFXInserted

      do_demo
      return


PUB do_demo | i,x,y,positionx,positiony,rate 

  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_8BIT_BITMAP_MODE,Lite#PROPGFX_0_3D_COGS,Lite#PROPGFX_FILLED_MODE,0)

  Lite.Set16ColourSprites
  Lite.SendBuf(@sprite_images,$5000,4096)  
  Lite.SendBuf(@sprite_pal,$1700,$100)

  '' Slider can be moved, but mouse won't find it... yet...
  '' (So don't move it until the next demo!)
  positionx:=50  '' location of control slider
  positiony:=40  '' location of control slider
  
  rate:=0 ''Setting 0-94 possible on control
  
  DrawControl (positionx,positiony)
  DrawPointer(100,20) '' Toss the mouse out somewhere

  '' Simple Demo to Help Sync the Screen
  '' Moves the Slider down, then back up to zero 
  repeat rate from 0 to 94
    DrawKnob (positionx,rate+positiony)
    rate++
    waitcnt(clkfreq /20 +cnt)
  repeat rate from 94 to 0
    DrawKnob (positionx,rate+positiony)
    rate--
    waitcnt(clkfreq /20 +cnt)  


  '' Read mouse to move control.
  repeat
    DrawKnob (positionx,rate+positiony)
    mousex := mousex + rat.delta_x '#> -128 <# 127
    mousey := mousey - rat.delta_y '#> -96 <# 95
    DrawPointer(mousex,mousey) 

    if rat.button(0)and mousex > 55 and mousex < 68
       rate:=mousey-40
       
       if rate < 0      '' Control limitations
          rate := 0
       if rate > 95
          rate := 95   

       DrawKnob (positionx,rate+positiony) 
       
PUB DrawControl(x,y)

  '' Draw a sprite control slider from some of the sprites
  Lite.SetSprite (1,x,y,0,0)  
  Lite.SetSprite (2,x+16,y,0,2)
  Lite.SetSprite (3,x,y+16,0,60)
  Lite.SetSprite (4,x+16,y+16,0,62)
  Lite.SetSprite (5,x,y+32,0,4)
  Lite.SetSprite (6,x+16,y+32,0,6)
  Lite.SetSprite (7,x,y+48,0,60)
  Lite.SetSprite (8,x+16,y+48,0,62)
  Lite.SetSprite (9,x,y+60,0,8)
  Lite.SetSprite (10,x+16,y+60,0,10)
  Lite.SetSprite (11,x,y+74,0,64)
  Lite.SetSprite (12,x+16,y+74,0,66)
  Lite.SetSprite (13,x,y+90,0,12)
  Lite.SetSprite (14,x+16,y+90,0,14)
  Lite.SetSprite (15,x,y+106,0,72)
  Lite.SetSprite (16,x+16,y+106,0,74)


PUB DrawKnob(x,reading)

  '' Draw Slider Control
  Lite.Setsprite (20,x+7,reading+1,0,20)
  Lite.Setsprite (21,x+7,reading+7,0,48)
  Lite.Setsprite (22,x+7,reading+12,0,76)

PUB DrawPointer (x,y)

  '' Draw Mouse Pointer
  Lite.SetSprite (30,x,y,0,22)
  Lite.SetSprite (31,x,y+8,0,50)


     
DAT
sprite_images  file      "sprites.chr"
sprite_pal     file      "sprites.pal"